import Module from 'module';
const { name } = [require][0]('./package.json');

const _resolveFilename = Module._resolveFilename;
const alias = new Set([
  'eslint-import-resolver-typescript',
  'eslint-plugin-jsx-a11y',
  'eslint-plugin-local',
  'eslint-plugin-n',
  'eslint-plugin-react-hooks',
  'eslint-plugin-rules',
]);

type CDR<T> = T extends [any, ...infer R] ? R : [];

Module._resolveFilename = function (
  request: string,
  ...args: CDR<Parameters<typeof _resolveFilename>>
) {
  if (alias.has(request)) {
    request = `${name}/${request}`;
  }
  return _resolveFilename(request, ...args);
};
